var xhrOverrideScript = document.createElement('script');
xhrOverrideScript.type = 'text/javascript';
xhrOverrideScript.innerHTML = `
(function () {
    //console.log('success1');
    var XHR = XMLHttpRequest.prototype;
    var send = XHR.send;
    var open = XHR.open;
    Object.defineProperty(this, 'response', { writable: true });
    Object.defineProperty(this, 'responseText', { writable: true });
    XHR.open = function (method, url) {
        this.url = url; // the request url
        return open.apply(this, arguments);
    }
    XHR.send = function () {
        this.addEventListener('readystatechange', function () {
          try {
            if(this.readyState !== 4) return;
            //console.log('success-load:' +this.url);
            if (typeof(this.url) !== "undefined" && this.url.indexOf('/ifsapplications/') >= 0) {
                if (typeof (window.clIFSAURENA) === "undefined") window.clIFSAURENA = [];
                var jsonField = null;
                try {
                    jsonField = JSON.parse(this.response);
                } catch (e) {
                }
                //if(jsonField !== null && this.url.indexOf('GetCurrentUserInformation') > 0) {
                //  for(key in jsonField) {
                //    if(key === "Name") {
                //      Object.defineProperty(this, "response", { writable: true });
                //      Object.defineProperty(this, "responseText", { writable: true });
                //      jsonField[key] = 'Michael Olsen';
                //      this.response = JSON.stringify(jsonField);
                //      this.responseText = this.response;
                //      console.log(this);
                //      break;
                //    }
                //  }
                //}
                //else if(jsonField !== null && this.url.indexOf('ClientNavigatorMain') > 0) {
                //  var r = this.response.replace('My Administration', 'xxxx admin');
                //  Object.defineProperty(this, "response", { writable: true });
                //  Object.defineProperty(this, "responseText", { writable: true });
                //  this.response = r;
                //  this.responseText = this.response;
                //  console.log(this);
                //}
                //else if(jsonField !== null && this.url.indexOf('GetSystemParameterList') > 0) {
                //  console.log('aaaaaaaaaaaa1');
                //  for(var i = 0; i < jsonField.value.length; i++) {
                //  console.log('aaaaaaaaaaaa2['+jsonField.value[i].Parameter+']');
                //    if(jsonField.value[i].Parameter === 'URL_HELP_BASE') {
                //  console.log('aaaaaaaaaaaa3');
                //      Object.defineProperty(this, "response", { writable: true });
                //      Object.defineProperty(this, "responseText", { writable: true });
                //      jsonField.value[i].Value = 'https://www.clicklearn.com';
                //      this.response = JSON.stringify(jsonField);
                //      this.responseText = this.response;
                //      console.log(this);
                //      break;
                //    }
                //  }
                //}
                for (var i = 0; i < window.clIFSAURENA.length && window.clIFSAURENA[i][0] !== this.url; i++);
                if (i == window.clIFSAURENA.length) {
                    window.clIFSAURENA.push([this.url, jsonField !== null ? jsonField : this.response]);
                }
                //console.log(window.orList);
            }
            else if (typeof(this.url) !== "undefined" && (this.url.indexOf('api/fsm/') >= 0 || this.url.indexOf('api/lobby/lobbyPage/') >= 0)) {
                var rurl = this.url.split("?v=")[0];
                if (typeof (window.clIFSFSM) === "undefined") window.clIFSFSM = [];
                var jsonField = null;
                try {
                    jsonField = JSON.parse(this.response);
                } catch (e) {
                }
                if (jsonField !== null && jsonField !== "") {
                  var i = -1;
                  if(rurl.indexOf("performFetchScreen") > 0) {
                    for (i = 0; i < window.clIFSFSM.length; i++) {
                      if(window.clIFSFSM[i][0] === rurl && jsonField.screenName === window.clIFSFSM[i][1].screenName) {
                        break;
                      }
                    }
                  }
                  else if(rurl.indexOf("performSequentialIndependentBatchRequest") > 0) {
                    for (i = 0; i < window.clIFSFSM.length && window.clIFSFSM[i][0] !== rurl; i++);
                    if (i == window.clIFSFSM.length) {
                        window.clIFSFSM.push([rurl, []]);
                    }
                    if(typeof(jsonField.responses) === "object") {
                      for(key in jsonField.responses) {
                        var obj = jsonField.responses[key];
                        for(var k = 0; k < obj.items.length; k ++) {
                          var itm = obj.items[k];
                          if(window.clIFSFSM[i][1].indexOf(itm) < 0) {
                            window.clIFSFSM[i][1].push(itm);
                          }
                        }
                      }
                    }
                    i = -1;
                  }
                  else {
                    for (i = 0; i < window.clIFSFSM.length && window.clIFSFSM[i][0] !== rurl; i++);
                  }
                  if (i == window.clIFSFSM.length) {
                      window.clIFSFSM.push([rurl, jsonField !== null ? jsonField : this.response]);
                  }
                  else if(i >= 0) {
                      window.clIFSFSM[i][1] = jsonField !== null ? jsonField : this.response;
                  }
                }
            }
          }
          catch(e) { 
            //console.log("********************************* exception:" + e.message); 
          }
        });
        return send.apply(this, arguments);
    };
})();
`;
if (document.head) {
    document.head.appendChild(xhrOverrideScript);
} else if (document.documentElement) {
    document.documentElement.appendChild(xhrOverrideScript);
}

chrome.runtime.onMessage.addListener(function (msg, sender, sendResponse) {
    // If the received message has the expected format...
    var response = "ERROR";
    try {
        if (msg.text === 'clGCextension') {
            response = "OK";
            var d = document;
            if (typeof (msg.sorg) !== "undefined") {
                //d.body.style.border = "dotted 2px purple";
                //d.body.style.backgroundColor = 'red';
                //if (window.self === window.top)
                //    d.body.style.backgroundColor = 'orange';
                //if (typeof (d.body) !== "undefined" && d.body !== null && d.body.getAttribute("cl-connector") !== "1" && typeof (window["clConnector"]) === "undefined") {
                if (typeof (window["clConnectorInitDone"]) === "undefined") {
                    response = "OK-1";
                    window["clConnectorInitDone"] = 1;
                    if (typeof (d.body) !== "undefined" && d.body !== null) {
                        d.body.setAttribute("cl-connector", "1");
                    }
                    var script = d.createElement('script');
                    script.setAttribute('type', 'text/javascript');
                    script.setAttribute('charset', 'UTF-8');
                    script.innerHTML = msg.sorg;
                    d.getElementsByTagName('head')[0].appendChild(script);
                    response = "OK-2";
                }
                else {
                    response = "Warning: alreadyloaded=" + typeof(d.body);
                }
            }
            else {
                response = "Error: Nosorg";
            }
            try {
                //response = "OK-3";
                if (msg.type === 4) { // inline record
                    ;
                }
                else if (msg.type === 200) { // ctlcol
                    window.postMessage({ text: "getCtlCol", type: msg.type, data: msg.data }, "*");
                }
                else if (msg.type >= 100) {
                    window.postMessage({ text: "endSpecialCommand", type: msg.type, data: msg.data }, "*");
                }
                else if (msg.type >= 2) { // Replay and Assist
                    if (msg.data.length > 0 && msg.data[0] === '!') {
                        var i = msg.data.indexOf("!", 1);
                        if (i > 1) {
                            msg.data = msg.data.substring(i + 1);
                        }
                    }
                    window.postMessage({ text: "findElement", type: msg.type, data: msg.data }, "*");
                }
                //response = "OK-4";
            } catch (e) {
                response = "Exception: " + e.message;
            }
        }
    } catch (e2) {
        response = "Exception2: " + e2.message;
    }
    sendResponse(response);
});

window.addEventListener("message", function (event) {
    try {
        if (event.data.text === "clGCconnectorSendMessage") {
            chrome.runtime.sendMessage(event.data);
        }
    } catch (e) {
        var emsg = e.message;
    }
}, false);
