function getCurrentTabUrl(callback) {
  var queryInfo = {
    active: true,
    currentWindow: true
  };
  chrome.tabs.query(queryInfo, function(tabs) {
    var tab = tabs[0];
    var url = tab.url; // tab.url is only available if the "activeTab" permission is declared. URL of other tabs (after removing active:true) from |queryInfo|, then the "tabs" permission is required
    callback(url);
  });
}

document.addEventListener('DOMContentLoaded', function() { getCurrentTabUrl(ShowPopup); });

function ShowPopup(url) {
    //document.getElementById("clREC").onclick = RecordNow;
    //document.getElementById("clNMH").onclick = changeNMH;
    var eclear = document.getElementById("clNMHclear");
    eclear.onclick = clNMHclear;
    chrome.storage.local.get("clConnectorWCu", function (sitem) {
        if (sitem !== null && typeof (sitem["clConnectorWCu"]) !== "undefined" && sitem["clConnectorWCu"] !== null && sitem["clConnectorWCu"] !== "") {
            document.getElementById("clNMHurl").innerText = sitem["clConnectorWCu"];
        }
    });
    chrome.storage.local.get("clConnectorWCs", function (sitem) {
        if (sitem !== null && typeof (sitem["clConnectorWCs"]) !== "undefined" && sitem["clConnectorWCs"] !== null && sitem["clConnectorWCs"] !== "") {
            document.getElementById("clNMHclear1").style.display = "block";
        }
    });
    //chrome.storage.local.get("clGCNMH", function (sitem) { if (sitem !== null) document.getElementById("clNMH").checked = sitem["clGCNMH"]; });

    var xhr = new XMLHttpRequest();
    var result = null;
    //try {
    //    xhr.open("POST", "http://127.0.0.1:16107?clGCconnector=click", false);
    //    xhr.send("");
    //    result = xhr.responseText;
    //    logit("resultX=" + result);
    //    if (result !== null && result.indexOf("OK=") === 0) {
    //        if (true) {
    //            chrome.extension.sendRequest({ msg: "updateAll", type: 1, data: result.substring(3) }, function (response) { });
    //            window.close();
    //        }
    //    }
    //    else if (result !== null && result.indexOf("REPLAY=") === 0) {
    //        chrome.extension.sendRequest({ msg: "updateAll", type: 2, data: result.substring(7) }, function (response) { });
    //        window.close();
    //    }
    //    else if (result !== null && result.indexOf("ASSIST=") === 0) {
    //        chrome.extension.sendRequest({ msg: "updateAll", type: 3, data: result.substring(7) }, function (response) { });
    //        window.close();
    //    }
    //    else {
    //        document.getElementById("clMSG").innerHTML = result;
    //    }
    //} catch (e) {
    //    document.getElementById("clMSG").innerHTML = "You need to record, replay or assist from your ClickLearn Studio application.";
    //}
    document.getElementById("clMSG").innerHTML = "You need to record, replay or assist from your ClickLearn Studio application.";
}

function logit(obj) {
    chrome.extension.getBackgroundPage().console.log(obj);  
}

function RecordNow() {
    chrome.extension.sendRequest({ msg: "updateAll", type: 4, data: "" }, function (response) { });
    window.close();
}

//function changeNMH() {
//    var isChecked = document.getElementById("clNMH").checked;
//    chrome.storage.local.set({ "clGCNMH": isChecked }, function () { doNMH(isChecked); });
//}

//function doNMH(isChecked) {
//    chrome.extension.sendRequest({ msg: "doNMH", data: isChecked }, function (response) { });
//}

function clNMHclear() {
    chrome.storage.local.remove(["clConnectorWCt","clConnectorWCs"], function () { });
    document.getElementById("clNMHclear1").style.display = "none";
    window.close();
}
